Index: main/plugin-forms/src/org/ametys/plugins/forms/workflow/FurtherInformationGenerator.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/workflow/FurtherInformationGenerator.java	(revision 0)
+++ main/plugin-forms/src/org/ametys/plugins/forms/workflow/FurtherInformationGenerator.java	(revision 0)
@@ -0,0 +1,131 @@
+/*
+ * Copyright 2016 Anyware Services
+ * 
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ * 
+ * http://www.apache.org/licenses/LICENSE-2.0
+ * 
+ * Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.forms.workflow;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.ProcessingException;
+import org.apache.cocoon.environment.ObjectModelHelper;
+import org.apache.cocoon.generation.ServiceableGenerator;
+import org.apache.cocoon.xml.AttributesImpl;
+import org.apache.cocoon.xml.XMLUtils;
+import org.xml.sax.SAXException;
+
+import org.ametys.plugins.forms.Field;
+import org.ametys.plugins.forms.Field.FieldType;
+import org.ametys.plugins.forms.Form;
+import org.ametys.plugins.forms.FormsException;
+import org.ametys.plugins.forms.data.FieldValue;
+import org.ametys.plugins.forms.data.UserEntry;
+import org.ametys.plugins.forms.jcr.FormPropertiesManager;
+import org.ametys.plugins.forms.table.FormTableManager;
+import org.ametys.runtime.user.CurrentUserProvider;
+import org.ametys.runtime.user.User;
+import org.ametys.runtime.user.UsersManager;
+
+/**
+ * Generator retrieving information for the further information requests
+ */
+public class FurtherInformationGenerator extends ServiceableGenerator
+{
+    /** Manager of the forms JCR representation */
+    private FormPropertiesManager _formPropertiesManager;
+    
+    /** Manager of the form entries SQL tables */
+    private FormTableManager _formTableManager;
+
+    /** Helper component allowing to retrieve information on the current user */
+    private CurrentUserProvider _currentUserProvider;
+
+    /** The users manager */
+    private UsersManager _usersManager;
+
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        _usersManager = (UsersManager) serviceManager.lookup(UsersManager.ROLE);
+        _currentUserProvider = (CurrentUserProvider) serviceManager.lookup(CurrentUserProvider.ROLE);
+        _formPropertiesManager = (FormPropertiesManager) serviceManager.lookup(FormPropertiesManager.ROLE);
+        _formTableManager = new FormTableManager();
+    }
+    
+    @SuppressWarnings("unchecked")
+    public void generate() throws IOException, SAXException, ProcessingException
+    {
+        contentHandler.startDocument();
+        XMLUtils.startElement(contentHandler, "further-information");
+        
+        // Retrieve the current user name and email
+        String login = _currentUserProvider.getUser();
+        User user = _usersManager.getUser(login);
+        
+        AttributesImpl atts = new AttributesImpl();
+        atts.addCDATAAttribute("email", user.getEmail());
+        atts.addCDATAAttribute("fullname", user.getFullName());
+        
+        XMLUtils.createElement(contentHandler, "current-user", atts);
+        
+        // Retrieve the email fields
+        Map<String, Object> jsParameters = (Map<String, Object>) objectModel.get(ObjectModelHelper.PARENT_CONTEXT);
+        String formId = (String) jsParameters.get("formId");
+        String entryId = (String) jsParameters.get("entryId");
+        
+        List<UserEntry> submission = null; 
+        try
+        {
+            Form form = _formPropertiesManager.getForm(formId);
+            Map<String, FieldValue> columns = _formTableManager.getColumns(form);
+            
+            submission = _formTableManager.getSubmissions(form, columns, 0, Integer.MAX_VALUE, new ArrayList<Integer>(Arrays.asList(Integer.valueOf(entryId))));
+        }
+        catch (FormsException e)
+        {
+            throw new ProcessingException("An error occured while trying to recover the user entry '" + entryId + "' of the form of id '" + formId + "'.");
+        }
+        
+        XMLUtils.startElement(contentHandler, "emails");
+        
+        List<FieldValue> entries = submission.get(0).getValues();
+        for (FieldValue entry : entries)
+        {
+            Field field = entry.getField();
+            if (FieldType.TEXT.equals(field.getType()))
+            {
+                Map<String, String> properties = field.getProperties();
+                if ("email".equals(properties.get("regexptype")) && entry.getValue() != null)
+                {
+                    atts.clear();
+                    
+                    atts.addCDATAAttribute("displayValue", field.getLabel() + ": " + (String) entry.getValue());
+                    atts.addCDATAAttribute("value", (String) entry.getValue());
+                    
+                    XMLUtils.createElement(contentHandler, "email", atts);
+                }
+            }
+        }
+        
+        XMLUtils.endElement(contentHandler, "emails");
+        
+        XMLUtils.endElement(contentHandler, "further-information");
+        contentHandler.endDocument();
+    }
+}
Index: main/plugin-forms/src/org/ametys/plugins/forms/workflow/RequestInformationFunction.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/workflow/RequestInformationFunction.java	(revision 0)
+++ main/plugin-forms/src/org/ametys/plugins/forms/workflow/RequestInformationFunction.java	(revision 0)
@@ -0,0 +1,76 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.forms.workflow;
+
+import java.util.Map;
+
+import javax.mail.MessagingException;
+
+import org.apache.avalon.framework.component.Component;
+import org.apache.avalon.framework.logger.AbstractLogEnabled;
+
+import org.ametys.runtime.plugins.core.mail.SendMailHelper;
+
+import com.opensymphony.module.propertyset.PropertySet;
+import com.opensymphony.workflow.FunctionProvider;
+import com.opensymphony.workflow.WorkflowException;
+
+/**
+ * OS workflow function to send mail after an action is triggered.
+ * The author of a form entry is also notified if the receipt is set
+ */
+public class RequestInformationFunction extends AbstractLogEnabled implements Component, FunctionProvider
+{
+    /** Actually send the email ? */
+    public static final String SEND_MAIL = "send-request-information-mail";
+    
+    /** Body of the email */
+    public static final String SENDER = "sender";
+    
+    /** Body of the email */
+    public static final String RECIPIENT = "recipient";
+
+    /** Subject of the email */
+    public static final String SUBJECT = "subject";
+    
+    /** Body of the email */
+    public static final String BODY = "body";
+    
+    @Override
+    public void execute(Map transientVars, Map args, PropertySet ps) throws WorkflowException
+    {
+        // If "send-mail" is set to true or is not present, send the mail.
+        boolean dontSendMail = "false".equals(transientVars.get(SEND_MAIL));
+        if (dontSendMail)
+        {
+            return;
+        }
+        
+        String sender = (String) transientVars.get(SENDER);
+        String recipient = (String) transientVars.get(RECIPIENT);
+        String subject = (String) transientVars.get(SUBJECT);
+        String body = (String) transientVars.get(BODY);
+        
+        try
+        {
+            SendMailHelper.sendMail(subject, null, body, recipient, sender);
+        }
+        catch (MessagingException e)
+        {
+            getLogger().warn("Could not send a workflow notification mail to " + recipient, e);
+        }
+    }
+}
Index: main/plugin-forms/stylesheets/export/excel.xsl
===================================================================
--- main/plugin-forms/stylesheets/export/excel.xsl	(revision 40266)
+++ main/plugin-forms/stylesheets/export/excel.xsl	(working copy)
@@ -47,6 +47,7 @@
                                 </xsl:choose>
                             </th>
                         </xsl:for-each>
+                        <th><i18n:text i18n:key="PLUGINS_FORMS_EXPORT_COLUMN_WORKFLOW_STEP"/></th>
                     </tr>
                 </thead>
             </xsl:if>
@@ -94,6 +95,11 @@
                                 </xsl:choose>
                             </td>
                         </xsl:for-each>
+                        <td>
+                            <xsl:if test="@workflowStep">
+                                <xsl:value-of select="@workflowStep" />
+                            </xsl:if>
+                        </td>
                     </tr>
                 </xsl:for-each>
             </tbody>
Index: main/plugin-forms/stylesheets/ribbon/ribbon.xsl
===================================================================
--- main/plugin-forms/stylesheets/ribbon/ribbon.xsl	(revision 0)
+++ main/plugin-forms/stylesheets/ribbon/ribbon.xsl	(revision 0)
@@ -0,0 +1,61 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!--
+   Copyright 2016 Anyware Services
+
+   Licensed under the Apache License, Version 2.0 (the "License");
+   you may not use this file except in compliance with the License.
+   You may obtain a copy of the License at
+
+       http://www.apache.org/licenses/LICENSE-2.0
+
+   Unless required by applicable law or agreed to in writing, software
+   distributed under the License is distributed on an "AS IS" BASIS,
+   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+   See the License for the specific language governing permissions and
+   limitations under the License.
+   -->
+<xsl:stylesheet version="1.0"
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+    xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
+    exclude-result-prefixes="i18n">
+    
+    <xsl:template match="root">
+        <xsl:apply-templates select="ribbon"/>
+    </xsl:template>
+    
+    <xsl:template match="*">
+        <xsl:copy>
+            <xsl:copy-of select="@*"/>
+            <xsl:apply-templates/>
+        </xsl:copy>
+    </xsl:template>
+
+    <!-- Copy the last tab and use its content in conjunction with the ribbon groups written in the workflow-tab tag to define the new tabs -->
+    <xsl:template match="tab[position() = last()]">
+        <xsl:copy-of select="."/>
+        <xsl:variable name="groups" select="./groups"/>
+        <xsl:variable name="contextualColor" select="@contextualColor" />
+        <xsl:variable name="contextualLabel" select="@contextualLabel" />
+        <xsl:variable name="contextualGroup" select="@contextualGroup" />
+        <xsl:variable name="label" select="@label" />
+        
+        <xsl:for-each select="/root/workflow-tab/group">
+            <tab>
+                <xsl:attribute name="id"><xsl:value-of select="../@tabId"/></xsl:attribute>
+                <xsl:attribute name="label"><xsl:value-of select="$label"/></xsl:attribute>
+                <xsl:attribute name="contextualColor"><xsl:value-of select="$contextualColor"/></xsl:attribute>
+                <xsl:attribute name="contextualLabel"><xsl:value-of select="$contextualLabel"/></xsl:attribute>
+                <xsl:attribute name="contextualGroup"><xsl:value-of select="$contextualGroup"/></xsl:attribute>
+                
+                <groups>
+                    <!-- Actions group -->
+	                <xsl:copy-of select="$groups/group"/>
+	                
+	                <!-- Workflow group -->
+	                <xsl:copy-of select="." />
+                </groups>
+            </tab>
+        </xsl:for-each>
+    </xsl:template>
+    
+</xsl:stylesheet>
